{$N+,E-,G+}
unit mndluni2;

INTERFACE
function mausinit:boolean; {Maus muss einmal initialisiert werden; FALSE=Fehler}
procedure maus(var lMaus: boolean; var Feld: string; anker: pointer;
               warte: boolean; var ch: char);
procedure mausS(var tastenr:byte; var mausx,mausy:word; warte:boolean);
procedure getMausxy(var x,y:word);
procedure erzeugeFeld(name,beschreib:string;x1,y1,x2,y2:word;var anker:pointer;cursor:byte);
procedure loescheFeld(name:string;var anker:pointer);
procedure loescheAlle(var anker:pointer);
procedure getFeldXY(name:string; var x1,y1,x2,y2:word; anker:pointer);
procedure versteckeCursor; {Darauf achten, nicht zweimal zu verstecken... }
procedure zeigeCursor;     {...oder zu zeigen!}
procedure setCursor(nummer: byte);
PROCEDURE SetMouseWindow(x1, y1, x2, y2: INTEGER);
PROCEDURE SetPos(x, y: INTEGER);
function zeit(std,min,sec,hsec:word):string;
function AktiveMaustaste:byte;
function erweiterung(name:string;soll:string):string;
procedure stelleSpeichern(dateiname:string; aecke,becke,seite:extended);
procedure stelleLaden(dateiname:string; var aecke,becke,seite:extended);
procedure textEingabe(var intext: string; laenge,xpos,ypos: word; farbe: byte);
function datum:string;

IMPLEMENTATION
uses
  dos,wandler,crt,graph;
type
  vCursor=record
            hotx,hoty:byte;
            aussehen:Array[0..1,0..15] Of Word;
          end;
  zeiger=^feld;
  feld=record
         name:string[10];
         beschreib:string;
         x1,y1,x2,y2:word;
         naechstes:zeiger;
         cursor:byte;
       end;
const
  lr:vCursor=(hotx:8; hoty:8; aussehen:
   (($FF8F,$FF87,$FF83,$FF81,$0000,$0000,$0000,$FFFF,$0000,$0000,$0000,$81FF,$C1FF,$E1FF,$F1FF,$FFFF),
   ($0000,$0030,$0038,$003C,$003E,$7FFE,$0000,$0000,$0000,$7FFE,$7C00,$3C00,$1C00,$0C00,$0000,$0000)));
  pfeil3:vCursor=(hotx:1; hoty:1; aussehen:
   (($00FF,$01FF,$03FF,$01FF,$00FF,$007F,$003F,$203F,$707F,$F8FF,$FDFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF),
   ($0000,$7C00,$7800,$7C00,$7E00,$7F00,$5F80,$0F80,$0700,$0200,$0000,$0000,$0000,$0000,$0000,$0000)));
  ziel:vCursor=(hotx:8; hoty:8; aussehen:
   (($FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF),
   ($0180,$0FF0,$399C,$2184,$6186,$4182,$4182,$FFFF,$FFFF,$4182,$4182,$6186,$2184,$399C,$0FF0,$0180)));
  ziel2:vCursor=(hotx:8; hoty:8; aussehen:
   (($FEFF,$F83F,$E6CF,$DEF7,$DEF7,$BEFB,$BEFB,$0001,$BEFB,$BEFB,$DEF7,$DEF7,$E6CF,$F83F,$FEFF,$FFFF),
   ($0100,$07C0,$1930,$2108,$2108,$4104,$4104,$FFFE,$4104,$4104,$2108,$2108,$1930,$07C0,$0100,$0000)));
  ende:vCursor=(hotx:8; hoty:8; aussehen:
   (($FFFF,$0BA3,$79A9,$79AD,$79AC,$78AE,$7AAE,$7AAE,$1AAE,$7AAE,$7AAE,$7A2E,$7B2C,$7B29,$0BA3,$FFFF),
   ($0000,$F45C,$8656,$8652,$8653,$8751,$8551,$8551,$E551,$8551,$8551,$85D1,$84D3,$84D6,$F45C,$0000)));
  kreuz:vCursor=(hotx:8; hoty:8; aussehen:
   (($3FFC,$1FF8,$8FF1,$C7E3,$E3C7,$F18F,$F81F,$FC3F,$FC3F,$F81F,$F18F,$E3C7,$C7E3,$8FF1,$1FF8,$3FFC),
   ($0000,$4002,$2004,$1008,$0810,$0420,$0240,$0180,$0180,$0240,$0420,$0810,$1008,$2004,$4002,$0000)));
  neu:vCursor=(hotx:8; hoty:8; aussehen:
   (($FFFF,$742E,$35EE,$35EE,$15EE,$15EE,$55EE,$55EE,$546E,$55EE,$55EE,$45EE,$65EE,$65E4,$7431,$FFFF),
   ($0000,$8BD1,$CA11,$CA11,$EA11,$EA11,$AA11,$AA11,$AB91,$AA11,$AA11,$BA11,$9A11,$9A1B,$8BCE,$0000)));
  go: vCursor = (hotx: 8; hoty: 8; aussehen:
   (($C7CE,$BBB6,$7D7A,$7D7A,$7F7A,$7F7A,$7F7A,$7F7A,$7F7A,$7F7A,$617A,$797A,$B97A,$B5B7,$CDCE,$FFFF),
   ($3831,$4449,$8285,$8285,$8085,$8085,$8085,$8085,$8085,$8085,$9E85,$8685,$4685,$4A48,$3231,$0000)));
  plusminu:vCursor=(hotx:9; hoty:9; aussehen:
   (($FFFF,$FE3F,$FE3F,$FE3F,$FE3F,$FE3F,$C63F,$8220,$8220,$8220,$C63F,$FE3F,$FE3F,$FE3F,$FE3F,$FFFF),
   ($0000,$0000,$0080,$0080,$0080,$0080,$0080,$1080,$388E,$1080,$0080,$0080,$0080,$0080,$0000,$0000)));
  einfuegn:vCursor=(hotx:8; hoty:9; aussehen:
   (($FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF),
   ($0000,$07C0,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$07C0,$0000)));
  boolea:vCursor=(hotx:9; hoty:8; aussehen:
   (($FCFF,$F06F,$E027,$C063,$8CF1,$1DF8,$1FF8,$1FF8,$1FF8,$1FF8,$0FB1,$8F23,$C607,$E40F,$F63F,$FF3F),
   ($0300,$0E90,$1058,$2E94,$530A,$A205,$A005,$A005,$A005,$A005,$904A,$50D4,$2968,$1A10,$0940,$00C0)));
  uhr2:vCursor=(hotx:1; hoty:8; aussehen:
   (($C007,$DFF7,$DFF7,$DFF7,$DFF7,$EFEF,$F7DF,$FBBF,$FD7F,$FD7F,$F39F,$EFEF,$DFF7,$DFF7,$DFF7,$C007),
   ($3FF8,$2008,$2008,$2008,$2008,$1010,$0C20,$0640,$0380,$0380,$0FE0,$17F0,$2FF8,$3FF8,$3FF8,$3FF8)));
  uhr3:vCursor=(hotx:1; hoty:8; aussehen:
   (($FFFF,$FFFF,$07F0,$7BEE,$7BDE,$7DBE,$7E7E,$7FFE,$7E7E,$7DBE,$7BDE,$7BEE,$07F0,$FFFF,$FFFF,$FFFF),
   ($0000,$0000,$F80F,$8411,$C421,$FA41,$FD81,$FF01,$FF81,$FE41,$FC21,$FC11,$F80F,$0000,$0000,$0000)));
  uhr4:vCursor=(hotx:1; hoty:8; aussehen:
   (($C007,$DFF7,$DFF7,$DFF7,$DFF7,$EFEF,$F7DF,$FBBF,$FD7F,$FD7F,$F39F,$EFEF,$DFF7,$DFF7,$DFF7,$C007),
   ($3FF8,$2008,$2028,$3858,$3EF8,$1FF0,$0FE0,$07C0,$0380,$0380,$0C60,$1110,$2008,$2388,$27E8,$3FF8)));
  uhr:vCursor=(hotx:1; hoty:8; aussehen:
   (($C007,$DFF7,$DFF7,$DFF7,$DFF7,$EFEF,$F7DF,$FBBF,$FD7F,$FD7F,$F39F,$EFEF,$DFF7,$DFF7,$DFF7,$C007),
   ($3FF8,$2008,$2008,$2008,$2808,$1C70,$0FE0,$07C0,$0380,$0380,$0D60,$1190,$27C8,$2FE8,$2FF8,$3FF8)));
  kasten:vCursor=(hotx:9; hoty:8; aussehen:
   (($FFFF,$CFF9,$C7F1,$E003,$F007,$F007,$F1C7,$F1C7,$F1C7,$F007,$F007,$E003,$C7F1,$CFF9,$FFFF,$FFFF),
   ($0000,$3006,$280A,$17F4,$0808,$0BE8,$0A28,$0A28,$0A28,$0BE8,$0808,$17F4,$280A,$3006,$0000,$0000)));

var
  m: Array[1..4] Of Word;
  aktzeiger: vCursor;

function datum:string;
var
  jahr,monat,tag,wochentag:word;
begin
  getdate(jahr,monat,tag,wochentag);
  datum:=int2str(tag)+'.'+int2str(monat)+'.'+int2str(jahr);
end;

procedure textEingabe(var intext: string; laenge,xpos,ypos: word; farbe: byte);
const
  menueFarbe=5;
var
  ch: char;
  zaehl: word;
  zk: string;
begin
  versteckeCursor;
  zk:='';
  zaehl:=0;
  setfillstyle(1,farbe);
  bar((xpos-1),(ypos-1),(xpos+laenge*8 - 1),(ypos+7));
  repeat
    ch:=readkey;
    if ((ch<>char(13))and(ch<>char(27))) then
    begin
      zk:=zk+ch;
      outtextxy((xpos+zaehl*8),ypos,ch);
    end;
    inc(zaehl);
  until ((ch=char(27)) or (ch=char(13)) or (zaehl >= laenge));
  if not(ch=char(27)) then intext:=zk;
  setfillstyle(1,menueFarbe);
  bar((xpos-1),(ypos-1),(xpos+laenge*8 - 1),(ypos+7));
  outtextxy(xpos,ypos,intext);
  zeigeCursor;
end; {textEingabe}

PROCEDURE Mausasm(var m:array of word);
BEGIN
  ASM
    LES DI,m
    MOV AX,ES:[DI]
    MOV BX,ES:[DI+2]
    MOV CX,ES:[DI+4]
    MOV DX,ES:[DI+6]
    INT $33
    MOV ES:[DI],AX
    MOV ES:[DI+2],BX
    MOV ES:[DI+4],CX
    MOV ES:[DI+6],DX
  END;
END;

procedure SetCursor(nummer:byte);
PROCEDURE LES; ASSEMBLER;
ASM
  MOV AX,Seg(aktzeiger.aussehen)
  MOV ES,AX
END;
begin
{  Sound(220); Delay(100); NoSound;}
  case nummer of
    1: aktzeiger:=lr;
    2: aktzeiger:=pfeil3;
    3: aktzeiger:=ziel;
    4: aktzeiger:=ende;
    5: aktzeiger:=kreuz;
    6: aktzeiger:=neu;
    7: aktzeiger:=go;
    8: aktzeiger:=kreuz;
    9: aktzeiger:=plusminu;
    10: aktzeiger:=einfuegn;
    11: aktzeiger:=boolea;
    12: aktzeiger:=uhr;
    13: aktzeiger:=uhr2;
    14: aktzeiger:=uhr3;
    15: aktzeiger:=uhr4;
    16: aktzeiger:=kasten;
    17: aktzeiger:=ziel2;
  end;
  m[1]:=2; mausasm(m);
  m[1]:=9;
  with aktzeiger do
  begin
    m[2]:=hotx;
    m[3]:=hoty;
    m[4]:=Ofs(aussehen);
  end;
  LES; mausasm(m);
  m[1]:=1; mausasm(m);
  m[1]:=3; mausasm(m);
end;

function zeit(std,min,sec,hsec:word):string;
var
  std2,min2,sec2,hsec2: word;
begin
  gettime(std2,min2,sec2,hsec2);
  if hsec2 < hsec then
  begin
    hsec:=(100-hsec+hsec2);
    inc(sec);
  end
  else hsec:=hsec2-hsec;
  if sec2 < sec then
  begin
    sec:=(60-sec+sec2);
    inc(min);
  end
  else sec:=sec2-sec;
  if min2 < min then
  begin
    min:=(60-min+min2);
    inc(std);
  end
  else min:=min2-min;
  if std2 < std then std:=(24-std+std2)
                else std:=std2-std;
  zeit:=int2str(std)+':'+int2str(min)+':'+int2str(sec)+':'+int2str(hsec);
end;

PROCEDURE SetMouseWindow(x1, y1, x2, y2: INTEGER); ASSEMBLER;
ASM
  MOV  AX, 0007h
  MOV  CX, x1
  MOV  DX, x2
  INT  33h
  MOV  AX, 0008h
  MOV  CX, y1
  MOV  DX, y2
  INT  33h
END;

procedure zeigeCursor; assembler;
ASM
  MOV AX, 0001h
  INT 33h
END;

procedure versteckeCursor; assembler;
ASM
  MOV AX, 0002h
  INT 33h
END;

PROCEDURE SetPos(x, y: INTEGER); ASSEMBLER;
ASM
  MOV  AX, 0004h
  MOV  CX, x
  MOV  DX, y
  INT  33h
END;

procedure LoescheFeld(name:string;var anker:pointer);
var
  lauf,vorgaenger:zeiger;
begin
  lauf:=anker;
  if lauf^.name=name then anker:=lauf^.naechstes else
  begin
    vorgaenger:=lauf;
    lauf:=lauf^.naechstes;
    while lauf<>nil do
      if lauf^.name=name then
      begin
        vorgaenger^.naechstes:=lauf^.naechstes;
        lauf:=nil;
      end
      else
      begin
        vorgaenger:=lauf;
        lauf:=lauf^.naechstes;
      end;
  end;
end;

procedure getFeldXY(name:string; var x1,y1,x2,y2:word; anker:pointer);
var
  lauf:zeiger;
begin
  lauf:=anker;
  while lauf<>nil do
    if lauf^.name=name then
    begin
      x1:=lauf^.x1;
      x2:=lauf^.x2;
      y1:=lauf^.y1;
      y2:=lauf^.y2;
      lauf:=nil;
    end
    else
      lauf:=lauf^.naechstes;
end;

procedure ErzeugeFeld(name,beschreib:string;x1,y1,x2,y2:word;var anker:pointer;cursor:byte);
var
  neu:zeiger;
begin
  new(neu);
  neu^.naechstes:=nil;
  neu^.name:=name;
  neu^.beschreib:=beschreib;
  neu^.x1:=x1;
  neu^.y1:=y1;
  neu^.x2:=x2;
  neu^.y2:=y2;
  neu^.cursor:=cursor;
  if anker=nil then anker:=neu else
  begin
    neu^.naechstes:=anker;
    anker:=neu;
  end;
end;

function mausinit:boolean;
begin
 if Mem[MemW[0:$cc+2]:MemW[0:$cc]]=$cf then mausinit:=false
  else                           {mouse.com gestartet?}
  begin
    m[1]:=0; Mausasm(m);       {0 = Initialisierung}
    m[1]:=1; Mausasm(m);       {1 = sichtbar machen}
    m[1]:=3; Mausasm(m);       {3 = Daten uebermitteln}
    mausinit:=true;
  end;
end;

procedure mausinfo2;
begin
  versteckeCursor;
  repeat
  bar(m[3],m[4],(m[3]+100),(m[4]+20));
  mausasm(m);
  outtextxy((m[3]+10),(m[4]+10),
    int2str(m[1])+':'+int2str(m[2])+':'+int2str(m[3])+':'+int2str(m[4]));
  until keypressed;
  zeigeCursor;
end;

procedure mausinfo;
begin
  versteckeCursor;
  bar(m[3],m[4],(m[3]+100),(m[4]+20));
  outtextxy((m[3]+10),(m[4]+10),
    int2str(m[1])+':'+int2str(m[2])+':'+int2str(m[3])+':'+int2str(m[4]));
  zeigeCursor;
end;

procedure beschreibung(text: string; m3,m4: word);
var
  count, altfarbe,xstelle,ystelle,groesse: word;
  x1,x2,y1,y2: integer;
  xmf: byte;
  bild: pointer;
  fuell: fillsettingstype;
begin
  count:=0;
  mausasm(m);
  while ((m[2] = 0) and (m[3]=m3) and (m[4]=m4) and not (keypressed)) do
  begin
    delay(1);
    if count < 501 then inc(count);
    mausasm(m);
    if count = 500 then
    if text<>'' then
    begin
      if getmaxx=319 then xmf:= 2 else xmf:= 1;
      altfarbe:= getcolor;
      getfillsettings(fuell);
      setcolor(0);
      setfillstyle(1,15);
      if (m3 div xmf + length(text) * 8) < getmaxx then
        if m3 div xmf > 3 then x1:=(m3 div xmf - 3) else x1:= 0
      else x1:=(m3 div xmf - (m3 div xmf + length(text) * 8 - getmaxx) - 4);
      x2:=(x1 + 8 * length(text) + 3);
      if x2 >= getmaxx then x2:= (getmaxx-1);
      if x1 < 1 then x1:= 1;
      if m4 < (getmaxy - 25) then y1:=(m4 + 17)
                             else y1:=(m4 - 15);
      y2:=(y1 + 10);
      groesse:=imagesize(x1,y1,x2,y2);
      getmem(bild,groesse);
      versteckeCursor;
      getImage(x1,y1,x2,y2,bild^);
      bar(x1,y1,x2,y2);
      outtextxy((x1+2),(y1+2),text);
      count:=0;
      zeigeCursor;
      while ((m[3]=m3) and (m[4]=m4) and (count < 6000) and not(keypressed)) do
      begin
        inc(count);
        delay(1);
        mausasm(m);
        if m[2] > 0 then count:=6000;
      end;
      setcolor(altfarbe);
      setfillstyle(fuell.pattern,fuell.color);
      versteckeCursor;
      putImage(x1,y1, bild^, normalput);
      zeigeCursor;
      freeMem(bild,groesse);
    end;
  end;
end;

procedure Maus(var lMaus:boolean;var Feld:string;anker:pointer;warte:boolean;var ch:char);
var
  zeige:zeiger;
  aktcursor:byte;
  originalCh: char;
begin
  if warte then
    repeat mausasm(m) until m[2]=0;
  aktcursor:=0;
  zeige:=anker;
  Feld:='';
  originalCh:=ch;
  repeat
    mausasm(m);
    while zeige<>nil do         {Feld suchen}
     if((m[3]>=zeige^.x1)and(m[3]<=zeige^.x2)and
       (m[4]>=zeige^.y1)and(m[4]<=zeige^.y2))then
     begin
       if aktcursor<>zeige^.cursor then
       begin
         aktcursor:=zeige^.cursor;
         SetCursor(aktcursor);
       end;
       beschreibung(zeige^.beschreib, m[3], m[4]);
       if m[2] > 0 then
       begin
         lMaus:=(m[2]=1);
         Feld:=zeige^.name;
       end;
       zeige:=nil;
     end
     else zeige:=zeige^.naechstes;
    zeige:=anker;
    if keypressed then
    begin
      ch:=readkey;
      if ord(ch) = 0 then ch:=readkey;
    end;
  until ((m[2]>0) or (ch<>originalCh));
  if warte then
    repeat mausasm(m) until m[2]=0;
end;

procedure MausS(var tastenr:byte; var mausx,mausy:word; warte:boolean);
begin
  mausasm(m);
  tastenr:=m[2];
  mausx:=m[3];
  mausy:=m[4];
  if ((tastenr <> 0) and warte) then
  repeat
    mausasm(m);
  until m[2]=0;
end;

procedure loescheAlle(var anker: pointer);
var z : zeiger;
 procedure deleteall(var ze : zeiger);
 begin
   if ze <> nil then
    begin
      deleteall(ze^.naechstes);
      dispose(ze);
    end;
 end;
begin
  z:=anker;
  deleteall(z);
  anker:= nil;
end;

function AktiveMaustaste:byte;
begin
  mausasm(m);
  AktiveMaustaste:=m[2];
end;

procedure getMausxy(var x,y:word);
begin
  mausasm(m);
  x:=m[3];
  y:=m[4];
end;

function erweiterung(name:string;soll:string):string;
var
  i:byte;
  gleich:boolean;
begin
  gleich:=true;
  for i:=0 to (length(soll)-1) do
  if upcase(name[length(name)-i])<>upcase(soll[length(soll)-i])
    then gleich:=false;
  if gleich then erweiterung:=name else
  begin
    if length(name)> 8 then delete(name,9,length(name));
    erweiterung:=(name+soll);
  end;
end;

procedure stelleSpeichern(dateiname:string; aecke,becke,seite:extended);
var
  datei: text;
begin
  assign(datei,dateiname);
  rewrite(datei);
  writeln(datei,'Positionsdaten, erzeugt von Vlado''s MandelZoom am '+datum);
  writeln(datei,'');
  writeln(datei,'x-Koordinate(Realteil): '+ext2str(aecke,0));
  writeln(datei,'y-Koordinate(Imaginaerteil): '+ext2str(becke,0));
  writeln(datei,'Groesse des Ausschnitts: '+ext2str(seite,0));
  close(datei);
end;

procedure stelleLaden(dateiname:string; var aecke,becke,seite:extended);
var
  datei: text;
  zeile: string;
begin
  assign(datei,dateiname);
  {$i-}
  reset(datei);
  {$i+}
  if ioresult=0 then
  begin
    readln(datei,zeile);
    delete(zeile,47,length(zeile));
    if zeile='Positionsdaten, erzeugt von Vlado''s MandelZoom' then
    begin
      readln(datei,zeile);
      readln(datei,zeile);
      delete(zeile,1,24);
      aecke:=str2ext(zeile);
      readln(datei,zeile);
      delete(zeile,1,29);
      becke:=str2ext(zeile);
      readln(datei,zeile);
      delete(zeile,1,25);
      seite:=str2ext(zeile);
    end;
    close(datei);
  end;
end;

end.
{$N-,E+,G-}